import numpy as np
import random


# qual x quan x acc
lamda_mt = abs(np.random.uniform(0.0, 10.0, (11, 101, 11))) # the distribution \lambda(r| d, t)

for i in range(11):
    for j in range(11):
        lamda_mt[i,j] = lamda_mt[i, j] / np.sum(lamda_mt[i, j])

D = 3
mmu = np.zeros((11)) # the prior \mu(d)

def cal_gaussian(x, m, v):
    if v == 0:
        if x == m:
            return 1.0
        else:
            return 0
    f = 1.0/ np.sqrt(2*np.pi*(v**2))
    f = f * np.exp(-0.5 * (x-m)**2/(v**2))
    return f
    

def compute_lambda(d, t):
    std = (-(t/100. - 0.5)**2 + 0.25)/10
    if t == 0 or t == 100:
        std = 0.
    m = np.round(d * ((t)/100.))

    if d == 0:
        std=0

    if 1:
        ff = np.zeros(11)
        for x in range(11):
            ff[x] = cal_gaussian(x, m, std)
        lamda_mt[d, t] = ff
        lamda_mt[d, t] = lamda_mt[d, t] / np.sum(ff)
        for x in range(11):
            if lamda_mt[d, t, x] < 1e-4:
                lamda_mt[d, t, x] = 0.0
        lamda_mt[d, t] = lamda_mt[d, t] / np.sum(lamda_mt[d, t])

            

## compute lambda
for i in range(11):
    for j in range(101):
        compute_lambda(i, j)


#compute_prior(d):
std = 3.0
for i in range(11):
    mmu[i]= cal_gaussian(i, D, std)
   
mmu = mmu / np.sum(mmu)



b0 = 5

# the valuation function with acc and type b
val = np.zeros((11, 11))
for i in range(10):
    ee = 10 - i
    for j in range(ee, 11):
        val[i + 1,j] = 10


val[10, 10] = 1000

# the valuation function with acc and type b
def val_f(r, b, r1):
    return val[r, b]
    


phiB = np.zeros(10)
for i in range(10):
    phiB[i] = 1.0/(10.)


# quan x acc.  # expected utiltiy of buyer (quantity x r_1 x type b)
exp_u = np.zeros((101, 11, 10))

def compute_r1_pro(r1, t): # probability Pr(r1 | t)
    f = 0.0
    for d in range(11):
        f = f + lamda_mt[d, t, r1] * mmu[d]
    return f
    
counts = 0

# compute utility of buyer given r1, quantity t, and type b
def compute_u(r1, t, B):

    deno = 0.0
    for d in range(11):
        deno = deno + lamda_mt[d, t, r1] * mmu[d]
    f=0.0
    for r2 in range(11):
        num = 0
        for d in range(11):
            num = num + lamda_mt[d, 100, r2] * lamda_mt[d, t, r1] * mmu[d]
        f = f + val_f(r2, B, r1) * num *1.0 

    #f = f - val_f(r1, B, 0) * deno   # comment it to model upper bound

    if abs(f) < 1e-7:   # if less than 1e-6, we say it is 0
        f = 0.
    
    return f



for t in range(101):
    for r1 in range(11):

        for b in range( 10):
            exp_u[t, r1, b] = compute_u(r1, t, b+1)
        

rev = np.zeros(101) # revenue wrt quantity
price = np.zeros((101, 11)) # price, given r1 and quantity t

for t in range(101):
    max_rev_t = 0.0
    sbl = []
    for r1 in range(11):
        max_rev = 0.0
        p_rt = 0.0
        sb = -1

        for i in range(10):  # posted price, find the best price by enumerating type b
            prob = 0.0
            for j in range(10):
                if exp_u[t, r1, j] >= exp_u[t, r1, i]:
                    prob = prob + phiB[j]
            if max_rev < prob * exp_u[t, r1, i]:
                sb = i
                max_rev = prob * exp_u[t, r1, i]
                p_rt = exp_u[t, r1, i]
        sbl.append(sb)
        price[t, r1] = p_rt

        max_rev_t = max_rev_t + max_rev

    rev[t] = max_rev_t

  
print(rev.tolist())
#np.savetxt("price.txt", price)













